#include "led.h"

disp_state_t ds;

//------------------------------------------------------------------------------
void init_led (void) {
//    ds.disp_ptr = 0;
//    ds.lightLevelCof = 1;
    ds.dispOn = 1;
    ds.dotOn = 0;
    ds.blink_disp = 0;
    PORTC = 0xff;
    ds.dotFlashTimer = 0;
    ds.dotFlash = 0;
    ds.dispFlash = 0;
    ds.dispFlashTimer = 0;
    
    ds.light_level_idx = ee_record.light_level_idx;
    if(ds.light_level_idx >= LIGHT_LEVELS_N) {
        ds.light_level_idx = 2;
    }
}
//------------------------------------------------------------------------------
inline void handle_disp (void) {
    ds.lightLevel = LIGHT_LEVELS[ds.light_level_idx];
    if(ds.segment_slot_counter > ds.lightLevel) {
        ds.segment_selector = 1;
        ds.segment_slot_counter = 0;
    }
}

void function_disp(void) {

#define DOT_MASQ 0x80
#define DISP_MASQ 0x7F

    dec_counter_zero(ds.dotFlashTimer);
    dec_counter_zero(ds.dispFlashTimer);
    
    ds.disp_buf = DISP1[ds.disp_val] & ds.dispMainMasq;
    static uint8_t blinkCnt = 0;
    uint8_t dotMasq, dispMasq;
    
    if(ds.dotFlash) {
        ds.dotFlashTimer = DOT_FLASH_TIME;
        ds.dotFlash = 0;
    }
    dotMasq = (ds.dotFlashTimer || ds.dotOn) ? DOT_MASQ : 0;
    
    if(ds.dispFlash) {
        ds.dispFlashTimer = 5;
        ds.dispFlash = 0;
    }
    dispMasq = (ds.dispFlashTimer || !ds.dispOn) ? 0 : DISP_MASQ;
    
    if(blinkCnt > 2 * BLINKT) {
        blinkCnt = 0;
        ds.dispMainMasq = dispMasq | dotMasq;
    } else if(blinkCnt > BLINKT) {
        if(ds.blink_disp) {
            ds.dispMainMasq &= ~(DISP_MASQ);
        }
        if(ds.blinkDot) {
            ds.dispMainMasq &= ~(DOT_MASQ);
        }
    } 
    blinkCnt++;

}
//------------------------------------------------------------------------------
